from Crypto.Cipher import AES
from Crypto.Util import Counter
from sys import argv
import hashlib
import struct
import os.path
import binascii

rol = lambda val, r_bits, max_bits: \
    (val << r_bits%max_bits) & (2**max_bits-1) | \
    ((val & (2**max_bits-1)) >> (max_bits-(r_bits%max_bits)))

def to_bytes(num):
    numstr = ''
    tmp = num
    while len(numstr) < 16:
        numstr += chr(tmp & 0xFF)
        tmp >>= 8
    return numstr[::-1]

if os.path.isfile(argv[1]):
    with open(argv[1], 'rb') as encryptedfile:


        KEY = long(argv[2], 16)
        IV = long(argv[3], 16)

        fileext = ".unk"
        if IV == 0x0000: fileext = ".cxi"
        if IV == 0x0001: fileext = ".cfa"
        if IV == 0x0002: fileext = ".cfa"
 
        IV = (IV << (14*8)) # IV = Content index + 14 bytes of 00's
        FILESIZEBYTES = os.stat(argv[1]).st_size
        FILESIZE = (FILESIZEBYTES / (1024*1024))
        FILESIZELEFT = (FILESIZEBYTES - (FILESIZE * (1024*1024)))
        print "AES Key : %032X" % (KEY)
        print "AES IV  : %032X" % (IV)
        print "FileSize: %10d" % (FILESIZEBYTES)
        print ""
        
        ctrmode = AES.new(to_bytes(KEY), AES.MODE_CBC, to_bytes(IV))

        with open(argv[1] + fileext, 'w+b') as decryptedfile:
            for i in xrange(0, FILESIZE):
                decryptedfile.write(ctrmode.decrypt(encryptedfile.read(1024*1024)))
                print 'Decrypting AES-CBC: %4d / %4d mb\r' % (i, FILESIZE + 1),
            if (FILESIZELEFT > 0):
                decryptedfile.write(ctrmode.decrypt(encryptedfile.read(FILESIZELEFT)))
                print 'Decrypting AES-CBC: %4d / %4d mb... Done!\r\n' % (FILESIZE + 1, FILESIZE + 1)
            print "Done!\r\n"
        
        with open(argv[1] + fileext, 'rb') as f:
            with open(argv[1] + fileext, 'rb+') as g:
                plain_counter = struct.unpack('>Q', '\x01\x00\x00\x00\x00\x00\x00\x00')
                exefs_counter = struct.unpack('>Q', '\x02\x00\x00\x00\x00\x00\x00\x00')
                romfs_counter = struct.unpack('>Q', '\x03\x00\x00\x00\x00\x00\x00\x00')
                KeyX0x18 = struct.unpack('>QQ', '\x82\xE9\xC9\xBE\xBF\xB8\xBD\xB8\x75\xEC\xC0\xA0\x7D\x47\x43\x74') # KeyX 0x18 (New 3DS <9.3)
                KeyX0x25 = struct.unpack('>QQ', '\xCE\xE7\xD8\xAB\x30\xC0\x0D\xAE\x85\x0E\xF5\xE3\x82\xAC\x5A\xF3') # KeyX 0x25 (> 7.x)
                KeyX0x2C = struct.unpack('>QQ', '\xB9\x8E\x95\xCE\xCA\x3E\x4D\x17\x1F\x76\xA9\x4D\xE9\x34\xC0\x53') # KeyX 0x2C (< 6.x)
                KeyX0x1B = struct.unpack('>QQ', '\x45\xAD\x04\x95\x39\x92\xC7\xC8\x93\x72\x4A\x9A\x7B\xCE\x61\x82') # KeyX 0x1B (New3DS >9.6)
                Constant = struct.unpack('>QQ', '\x1F\xF9\xE9\xAA\xC5\xFE\x04\x08\x02\x45\x91\xDC\x5D\x52\x76\x8A') # 3DS AES Hardware Constant

                f.seek(0x100) # Seek to 0x100 to find NCCH header
                magic = f.read(0x04)

                if magic == "NCCH": # check if file is valid
                    f.seek(0x0)
                    part_keyy = struct.unpack('>QQ', f.read(0x10)) # KeyY is the first 16 bytes of partition RSA-2048 SHA-256 signature

                    f.seek(0x108)
                    tid = struct.unpack('<Q', f.read(0x8)) # TitleID is used as IV joined with the content type.
                    plain_iv = (tid[::] + plain_counter[::]) # Get the IV for plain sector (TitleID + Plain Counter)
                    exefs_iv = (tid[::] + exefs_counter[::]) # Get the IV for ExeFS (TitleID + ExeFS Counter)
                    romfs_iv = (tid[::] + romfs_counter[::]) # Get the IV for RomFS (TitleID + RomFS Counter)

                    f.seek(0x160) # get exheader hash
                    exhdr_sbhash = str("%016X%016X%016X%016X") % (struct.unpack('>QQQQ', f.read(0x20)))

                    f.seek(0x180)
                    exhdr_len = struct.unpack('<L', f.read(0x04)) # get extended header length

                    f.seek(0x188)
                    partition_flags = struct.unpack('<BBBBBBBB', f.read(0x08)) # get partition flags
                    sectorsize = ((2**partition_flags[6]) * 0x200)

                    f.seek(0x190)
                    plain_off = struct.unpack('<L', f.read(0x04)) # get plain sector offset
                    plain_len = struct.unpack('<L', f.read(0x04)) # get plain sector length

                    f.seek(0x198)
                    logo_off = struct.unpack('<L', f.read(0x04)) # get logo offset
                    logo_len = struct.unpack('<L', f.read(0x04)) # get logo length

                    f.seek(0x1A0)
                    exefs_off = struct.unpack('<L', f.read(0x04)) # get exefs offset
                    exefs_len = struct.unpack('<L', f.read(0x04)) # get exefs length

                    f.seek(0x1B0)
                    romfs_off = struct.unpack('<L', f.read(0x04)) # get romfs offset
                    romfs_len = struct.unpack('<L', f.read(0x04)) # get romfs length

                    f.seek(0x1C0) # get exefs hash
                    exefs_sbhash = str("%016X%016X%016X%016X") % (struct.unpack('>QQQQ', f.read(0x20)))

                    f.seek(0x1E0) # get romfs hash
                    romfs_sbhash = str("%016X%016X%016X%016X") % (struct.unpack('>QQQQ', f.read(0x20)))

                    plainIV = long(str("%016X%016X") % (plain_iv[::]), 16)
                    exefsIV = long(str("%016X%016X") % (exefs_iv[::]), 16)
                    romfsIV = long(str("%016X%016X") % (romfs_iv[::]), 16)
                    KeyY = long(str("%016X%016X") % (part_keyy[::]), 16)
                    Const = long(str("%016X%016X") % (Constant[::]), 16)

                    KeyX2C = long(str("%016X%016X") % (KeyX0x2C[::]), 16)
                    KeyX25 = long(str("%016X%016X") % (KeyX0x25[::]), 16)
                    KeyX18 = long(str("%016X%016X") % (KeyX0x18[::]), 16)
                    KeyX1B = long(str("%016X%016X") % (KeyX0x1B[::]), 16)

                    NormalKey2C = rol((rol(KeyX2C, 2, 128) ^ KeyY) + Const, 87, 128)

                    if (partition_flags[7] & 0x20):
                        # seed crypto is used
                        Seed = long(argv[4], 16)
                        #print "KeyY: %032X" % (KeyY)
                        #print "Seed: %032X" % (Seed)
                        # SHA-256 of 0x10 byte KeyY and 0x10 byte seed.
                        seedhash = hashlib.sha256()
                        seedhash.update(binascii.unhexlify(str("%032X%032X") % (KeyY, Seed)))
                        KeyYSeed = long(seedhash.hexdigest()[:32].upper(), 16)
                        #print "Hash: %s" % seedhash.hexdigest()[:32].upper()
                        if (partition_flags[3] == 0x00): NormalKey = rol((rol(KeyX2C, 2, 128) ^ KeyYSeed) + Const, 87, 128)
                        if (partition_flags[3] == 0x01): NormalKey = rol((rol(KeyX25, 2, 128) ^ KeyYSeed) + Const, 87, 128)
                        if (partition_flags[3] == 0x0A): NormalKey = rol((rol(KeyX18, 2, 128) ^ KeyYSeed) + Const, 87, 128)
                        if (partition_flags[3] == 0x0B): NormalKey = rol((rol(KeyX1B, 2, 128) ^ KeyYSeed) + Const, 87, 128)
                    else:
                        if (partition_flags[3] == 0x00): NormalKey = rol((rol(KeyX2C, 2, 128) ^ KeyY) + Const, 87, 128)
                        if (partition_flags[3] == 0x01): NormalKey = rol((rol(KeyX25, 2, 128) ^ KeyY) + Const, 87, 128)
                        if (partition_flags[3] == 0x0A): NormalKey = rol((rol(KeyX18, 2, 128) ^ KeyY) + Const, 87, 128)
                        if (partition_flags[3] == 0x0B): NormalKey = rol((rol(KeyX1B, 2, 128) ^ KeyY) + Const, 87, 128)

                    if (exhdr_len[0] > 0):
                        # decrypt exheader
                        f.seek(sectorsize)
                        g.seek(sectorsize)
                        exhdr_filelen = 0x800
                        exefsctr2C = Counter.new(128, initial_value=(plainIV))
                        exefsctrmode2C = AES.new(to_bytes(NormalKey2C), AES.MODE_CTR, counter = exefsctr2C)
                        print ("Decrypting ExeFS: ExHeader")
                        g.write(exefsctrmode2C.decrypt(f.read(exhdr_filelen)))
                        
                    # Decrypt ExeFS
                    if (exefs_len[0] > 0):
                        # decrypt filename table
                        f.seek((exefs_off[0]) * sectorsize)
                        g.seek((exefs_off[0]) * sectorsize)
                        exefsIV = long(str("%016X%016X") % (exefs_iv[::]), 16)
                        exefsctr = Counter.new(128, initial_value=(exefsIV))
                        exefsctrmode = AES.new(to_bytes(NormalKey2C), AES.MODE_CTR, counter = exefsctr)
                        g.write(exefsctrmode.decrypt(f.read(sectorsize)))
                        print ("Decrypting ExeFS: Filename Table")

                        if ( partition_flags[3] == 0x01 or partition_flags[3] == 0x0A or partition_flags[3] == 0x0B ):
                            code_filelen = 0
                            for j in xrange(10): # 10 exefs filename slots
                                # get filename, offset and length
                                f.seek(((exefs_off[0]) * sectorsize) + j*0x10)
                                g.seek(((exefs_off[0]) * sectorsize) + j*0x10)
                                exefs_filename = struct.unpack('<8s', g.read(0x08))
                                if str(exefs_filename[0]) == str(".code\x00\x00\x00"):
                                    code_fileoff = struct.unpack('<L', g.read(0x04))
                                    code_filelen = struct.unpack('<L', g.read(0x04))
                                    datalenM = ((code_filelen[0]) / (1024*1024))
                                    datalenB = ((code_filelen[0]) % (1024*1024))
                                    ctroffset = ((code_fileoff[0] + sectorsize) / 0x10)
                                    exefsctr = Counter.new(128, initial_value=(exefsIV + ctroffset))
                                    exefsctr2C = Counter.new(128, initial_value=(exefsIV + ctroffset))
                                    exefsctrmode = AES.new(to_bytes(NormalKey), AES.MODE_CTR, counter = exefsctr)
                                    exefsctrmode2C = AES.new(to_bytes(NormalKey2C), AES.MODE_CTR, counter = exefsctr2C)
                                    f.seek((((exefs_off[0]) + 1) * sectorsize) + code_fileoff[0])
                                    g.seek((((exefs_off[0]) + 1) * sectorsize) + code_fileoff[0])                                        
                                    if (datalenM > 0):
                                        for i in xrange(datalenM):
                                            g.write(exefsctrmode2C.encrypt(exefsctrmode.decrypt(f.read(1024*1024))))
                                            print ("\rDecrypting ExeFS: %8s... %4d / %4d mb...") % (str(exefs_filename[0]), i, datalenM + 1),
                                    if (datalenB > 0):
                                        g.write(exefsctrmode2C.encrypt(exefsctrmode.decrypt(f.read(datalenB))))
                                    print ("\rDecrypting ExeFS: %8s... %4d / %4d mb... Done!") % (str(exefs_filename[0]), datalenM + 1, datalenM + 1)

                        # Decrypt ExeFS
                        exefsSizeM = ((exefs_len[0] - 1) * sectorsize) / (1024*1024)
                        exefsSizeB = ((exefs_len[0] - 1) * sectorsize) % (1024*1024)
                        ctroffset = (sectorsize / 0x10)
                        exefsctr2C = Counter.new(128, initial_value=(exefsIV + ctroffset))
                        exefsctrmode2C = AES.new(to_bytes(NormalKey2C), AES.MODE_CTR, counter = exefsctr2C)
                        f.seek((exefs_off[0] + 1) * sectorsize)
                        g.seek((exefs_off[0] + 1) * sectorsize)
                        if (exefsSizeM > 0):
                            for i in xrange(exefsSizeM):
                                g.write(exefsctrmode2C.decrypt(f.read(1024*1024)))
                                print ("\rDecrypting ExeFS: %4d / %4d mb") % (i, exefsSizeM + 1),
                        if (exefsSizeB > 0):
                            g.write(exefsctrmode2C.decrypt(f.read(exefsSizeB)))
                        print ("\rDecrypting ExeFS: %4d / %4d mb... Done") % (exefsSizeM + 1, exefsSizeM + 1)

                    else:
                        print ("ExeFS: No Data... Skipping...")

                    if (romfs_off[0] != 0):
                        romfsSizeM = (romfs_len[0] * sectorsize) / (1024*1024)
                        romfsSizeB = (romfs_len[0] * sectorsize) % (1024*1024)

                        romfsctr = Counter.new(128, initial_value=romfsIV)
                        romfsctrmode = AES.new(to_bytes(NormalKey), AES.MODE_CTR, counter = romfsctr)

                        f.seek((romfs_off[0]) * sectorsize)
                        g.seek((romfs_off[0]) * sectorsize)
                        if (romfsSizeM > 0):
                            for i in xrange(romfsSizeM):
                                g.write(romfsctrmode.decrypt(f.read(1024*1024)))
                                print ("\rDecrypting RomFS: %4d / %4d mb") % (i, romfsSizeM + 1),
                        if (romfsSizeB > 0):
                            g.write(romfsctrmode.decrypt(f.read(romfsSizeB)))
                        print ("\rDecrypting RomFS: %4d / %4d mb... Done") % (romfsSizeM + 1, romfsSizeM + 1)
                 
                    else:
                        print ("RomFS: No Data... Skipping...")

                    g.seek(0x18B)
                    g.write(struct.pack('<B', int(0x00))) # set crypto-method to 0x00
                    g.seek(0x18F)
                    flag = int(partition_flags[7]) # read partition flag
                    flag = (flag & ((0x01|0x20)^0xFF)) # turn off 0x01 = FixedCryptoKey and 0x20 = CryptoUsingNewKeyY
                    flag = (flag | 0x04) # turn on 0x04 = NoCrypto
                    g.write(struct.pack('<B', int(flag))) # write flag

                    print "Done..."
                    
